#include "DS18B20.h"

void Delay400us()		//@24.000MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 2398UL;
	while (i) i--;
}


void Delay60us()		//@24.000MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 358UL;
	while (i) i--;
}


void Delay1us()		//@24.000MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 4UL;
	while (i) i--;
}


void DS18B20_Reset(void)		// λ
{
	bit flag = 1;
	
	while(flag)
	{
		DQ = 0;		// ͵ƽ
		Delay400us();
		DQ = 1;		// ߵƽ
		Delay60us();
		flag = DQ;	// ȡǰƽ
		Delay400us();
	}
}


void DS18B20_Write_0(void)		// д߼0
{
	DQ = 0;		// ͵ƽ
	Delay60us();
	DQ = 1;		// ߵƽ
	Delay1us();
	Delay1us();
}


void DS18B20_Write_1(void)		// д߼1
{
	DQ = 0;		// ͵ƽ
	Delay1us();
	Delay1us();
	DQ = 1;		// ߵƽ
	Delay60us();
}


bit DS18B20_Read(void)		// ȡƽ
{
	bit state;
	DQ = 0;		// ͵ƽ
	Delay1us();
	Delay1us();
	DQ = 1;		// ߵƽ
	Delay1us();
	Delay1us();
	state = DQ;	// ȡǰƽ
	
	Delay60us();
	return state;
}


// 0xCC = 1100 1100 & 0x01
void DS18B20_WriteByte(u8 dat)		// дһֽ
{
	u8 i;
	for(i=0; i<8; i++)
	{
		if(dat & 0x01)
		{
			DS18B20_Write_1();
		}
		else
		{
			DS18B20_Write_0();
		}
		dat = dat >> 1;
	}
}


u8 DS18B20_ReadByte(void)
{
	u8 i;
	u8 dat = 0;
	for(i=0; i<8; i++)
	{
		dat = dat >> 1;
		if(DS18B20_Read())
		{
			dat |= 0x80;
		}
	}
	return dat;
}

float DS18B20_ReadTemp(void)
{
	u8 TempH;
	u8 TempL;
	u16 TempU16Var;
	u16 TempFloatVar;
	
	DS18B20_Reset();				// λ
	DS18B20_WriteByte(0xCC);		// ROMָ
	DS18B20_WriteByte(0x44);		// дһֽ
	while(!DQ);						// ȴDQɸߵƽ
	
	DS18B20_Reset();				// λ
	DS18B20_WriteByte(0xCC);		// ROMָ
	DS18B20_WriteByte(0xBE);		// ȡ
	
	TempL = DS18B20_ReadByte();
	TempH = DS18B20_ReadByte();
	
	TempU16Var = ((TempH<<8) | TempL);
	if(TempH & 0xF8) // 1־Ǹ
	{
		TempU16Var = (~TempU16Var) + 1;
		TempFloatVar = (float)TempU16Var * -1;
	}
	else
	{
		TempFloatVar = (float)TempU16Var;
	}
	
	TempFloatVar = TempFloatVar * 0.0625;
	return TempFloatVar;
}
